<?php

class Magefast_Seflinkmultilanguage_Helper_Catalog_Product_Url extends Mage_Catalog_Helper_Product_Url
{
    
    /**
     * Symbol convert table
     *
     * @var array
     */
    protected $_convertTable = array(
        '&amp;' => 'and',   '@' => 'at',    '©' => '%A9', '®' => '%AE', 'À' => '%C0',
        'Á' => '%C1', 'Â' => '%C2', 'Ä' => '%C4', 'Å' => '%C5', 'Æ' => '%C6','Ç' => '%C7',
        'È' => '%C8', 'É' => '%C9', 'Ë' => '%CB', 'Ì' => '%CC', 'Í' => '%CD', 'Î' => '%CE',
        'Ï' => '%CF', 'Ò' => 'o', 'Ó' => 'o', 'Ô' => 'o', 'Õ' => 'o', 'Ö' => 'o',
        'Ø' => 'o', 'Ù' => 'u', 'Ú' => 'u', 'Û' => 'u', 'Ü' => 'u', 'Ý' => 'y',
        'ß' => 'ss','à' => 'a', 'á' => 'a', 'â' => 'a', 'ä' => 'a', 'å' => 'a',
        'æ' => 'ae','ç' => 'c', 'è' => 'e', 'é' => 'e', 'ê' => 'e', 'ë' => 'e',
        'ì' => 'i', 'í' => 'i', 'î' => 'i', 'ï' => 'i', 'ò' => 'o', 'ó' => 'o',
        'ô' => 'o', 'õ' => 'o', 'ö' => 'o', 'ø' => 'o', 'ù' => 'u', 'ú' => 'u',
        'û' => 'u', 'ü' => 'u', 'ý' => 'y', 'þ' => 'p', 'ÿ' => 'y', 'Ā' => 'a',
        'ā' => 'a', 'Ă' => 'a', 'ă' => 'a', 'Ą' => 'a', 'ą' => 'a', 'Ć' => 'c',
        'ć' => 'c', 'Ĉ' => 'c', 'ĉ' => 'c', 'Ċ' => 'c', 'ċ' => 'c', 'Č' => 'c',
        'č' => 'c', 'Ď' => 'd', 'ď' => 'd', 'Đ' => 'd', 'đ' => 'd', 'Ē' => 'e',
        'ē' => 'e', 'Ĕ' => 'e', 'ĕ' => 'e', 'Ė' => 'e', 'ė' => 'e', 'Ę' => 'e',
        'ę' => 'e', 'Ě' => 'e', 'ě' => 'e', 'Ĝ' => 'g', 'ĝ' => 'g', 'Ğ' => 'g',
        'ğ' => 'g', 'Ġ' => 'g', 'ġ' => 'g', 'Ģ' => 'g', 'ģ' => 'g', 'Ĥ' => 'h',
        'ĥ' => 'h', 'Ħ' => 'h', 'ħ' => 'h', 'Ĩ' => 'i', 'ĩ' => 'i', 'Ī' => 'i',
        'ī' => 'i', 'Ĭ' => 'i', 'ĭ' => 'i', 'Į' => 'i', 'į' => 'i', 'İ' => 'i',
        'ı' => 'i', 'Ĳ' => 'ij','ĳ' => 'ij','Ĵ' => 'j', 'ĵ' => 'j', 'Ķ' => 'k',
        'ķ' => 'k', 'ĸ' => 'k', 'Ĺ' => 'l', 'ĺ' => 'l', 'Ļ' => 'l', 'ļ' => 'l',
        'Ľ' => 'l', 'ľ' => 'l', 'Ŀ' => 'l', 'ŀ' => 'l', 'Ł' => 'l', 'ł' => 'l',
        'Ń' => 'n', 'ń' => 'n', 'Ņ' => 'n', 'ņ' => 'n', 'Ň' => 'n', 'ň' => 'n',
        'ŉ' => 'n', 'Ŋ' => 'n', 'ŋ' => 'n', 'Ō' => 'o', 'ō' => 'o', 'Ŏ' => 'o',
        'ŏ' => 'o', 'Ő' => 'o', 'ő' => 'o', 'Œ' => 'oe','œ' => 'oe','Ŕ' => 'r',
        'ŕ' => 'r', 'Ŗ' => 'r', 'ŗ' => 'r', 'Ř' => 'r', 'ř' => 'r', 'Ś' => 's',
        'ś' => 's', 'Ŝ' => 's', 'ŝ' => 's', 'Ş' => 's', 'ş' => 's', 'Š' => 's',
        'š' => 's', 'Ţ' => 't', 'ţ' => 't', 'Ť' => 't', 'ť' => 't', 'Ŧ' => 't',
        'ŧ' => 't', 'Ũ' => 'u', 'ũ' => 'u', 'Ū' => 'u', 'ū' => 'u', 'Ŭ' => 'u',
        'ŭ' => 'u', 'Ů' => 'u', 'ů' => 'u', 'Ű' => 'u', 'ű' => 'u', 'Ų' => 'u',
        'ų' => 'u', 'Ŵ' => 'w', 'ŵ' => 'w', 'Ŷ' => 'y', 'ŷ' => 'y', 'Ÿ' => 'y',
        'Ź' => 'z', 'ź' => 'z', 'Ż' => 'z', 'ż' => 'z', 'Ž' => 'z', 'ž' => 'z',
        'ſ' => 'z', 'Ə' => 'e', 'ƒ' => 'f', 'Ơ' => 'o', 'ơ' => 'o', 'Ư' => 'u',
        'ư' => 'u', 'Ǎ' => 'a', 'ǎ' => 'a', 'Ǐ' => 'i', 'ǐ' => 'i', 'Ǒ' => 'o',
        'ǒ' => 'o', 'Ǔ' => 'u', 'ǔ' => 'u', 'Ǖ' => 'u', 'ǖ' => 'u', 'Ǘ' => 'u',
        'ǘ' => 'u', 'Ǚ' => 'u', 'ǚ' => 'u', 'Ǜ' => 'u', 'ǜ' => '%C7%9C', 'Ǻ' => '%C7%BA',
        'ǻ' => '%C7%BB', 'Ǽ' => '%C7%BC','ǽ' => '%C7%BD','Ǿ' => '%C7%BE', 'ǿ' => '%C7%BF', 'ə' => '%C9%99',
        'Ё' => '%D0%81', 'Є' => '%D0%84', 'І' => '%D0%86', 'Ї' => '%D0%87', 'А' => '%D0%90', 'Б' => '%D0%91',
        'В' => '%D0%92', 'Г' => '%D0%93', 'Д' => '%D0%94', 'Е' => '%D0%95', 'Ж' => '%D0%96', 'З' => '%D0%97',
        'И' => '%D0%98', 'Й' => '%D0%99', 'К' => '%D0%9A', 'Л' => '%D0%9B', 'М' => '%D0%9C', 'Н' => '%D0%9D',
        'О' => '%D0%9E', 'П' => '%D0%9F', 'Р' => '%D0%A0', 'С' => '%D0%A1', 'Т' => '%D0%A2', 'У' => '%D0%A3',
        'Ф' => '%D0%A4', 'Х' => '%D0%A5', 'Ц' => '%D0%A6', 'Ч' => '%D0%A7', 'Ш' => '%D0%A8', 'Щ' => '%D0%A9',
        'Ъ' => '%D0%AA', 'Ы' => '%D0%AB', 'Ь' => '%D0%AC', 'Э' => '%D0%AD', 'Ю' => '%D0%AE', 'Я' => '%D0%AF',
        'а' => '%D0%B0', 'б' => '%D0%B1', 'в' => '%D0%B2', 'г' => '%D0%B3', 'д' => '%D0%B4', 'е' => '%D0%B5',
        'ж' => '%D0%B6', 'з' => '%D0%B7', 'и' => '%D0%B8', 'й' => '%D0%B9', 'к' => '%D0%BA', 'л' => '%D0%BB',
        'м' => '%D0%BC', 'н' => '%D0%BD', 'о' => '%D0%BE', 'п' => '%D0%BF', 'р' => '%D1%80', 'с' => '%D1%81',
        'т' => '%D1%82', 'у' => '%D1%83', 'ф' => '%D1%84', 'х' => '%D1%85', 'ц' => '%D1%86', 'ч' => '%D1%87',
        'ш' => '%D1%88', 'щ' => '%D1%89', 'ъ' => '%D1%8A', 'ы' => '%D1%8B', 'ь' => '%D1%8C', 'э' => '%D1%8D',
        'ю' => '%D1%8E', 'я' => '%D1%8F', 'ё' => '%D1%91', 'є' => '%D1%94', 'і' => '%D1%96', 'ї' => '%D1%97',
        'Ґ' => '%D2%90', 'ґ' => '%D2%91', 'א' => '%D7%90', 'ב' => '%D7%91', 'ג' => '%D7%92', 'ד' => '%D7%93',
        'ה' => '%D7%94', 'ו' => '%D7%95', 'ז' => '%D7%96', 'ח' => '%D7%97', 'ט' => '%D7%98', 'י' => '%D7%99',
        'ך' => '%D7%9A', 'כ' => '%D7%9B', 'ל' => '%D7%9C', 'ם' => '%D7%9D', 'מ' => '%D7%9E', 'ן' => '%D7%9F',
        'נ' => '%D7%A0', 'ס' => '%D7%A1', 'ע' => '%D7%A2', 'ף' => '%D7%A3', 'פ' => '%D7%A4', 'ץ' => '%D7%A5',
        'צ' => '%D7%A6', 'ק' => '%D7%A7', 'ר' => '%D7%A8', 'ש' => '%D7%A9', 'ת' => '%D7%AA', '™' => '%E2%84%A2',
    );

    /**
     * Check additional instruction for convertation table in configuration
     */
    public function __construct()
    {
        $convertNode = Mage::getConfig()->getNode('default/url/convert');
        if ($convertNode){
            foreach ($convertNode->children() as $node) {
                $this->_convertTable[strval($node->from)] = strval($node->to);
            }
        }
    }

    /**
     * Get chars convertation table
     *
     * @return array
     */
    public function getConvertTable()
    {
        return $this->_convertTable;
    }

    /**
     * Process string based on convertation table
     *
     * @param   string $string
     * @return  string
     */
    public function format($string)
    {
        return strtr($string, $this->getConvertTable());
    }
}
